Subject: Re: [PATCH] net: release dst entry in dev_hard_start_xmit()

From: Jarek Poplawski <[email-masked]>
Date: Tue, 12 May 2009 22:59:12 +0200

On Tue, May 12, 2009 at 10:52:27PM +0200, Eric Dumazet wrote:
> Jarek Poplawski a écrit :
> > On Tue, May 12, 2009 at 09:44:52PM +0200, Eric Dumazet wrote:
> >> Jarek Poplawski a écrit :
> >>> On Tue, May 12, 2009 at 10:21:12AM +0200, Eric Dumazet wrote:
> >>>> Eric Dumazet a écrit :
> >>> ...
> >>>>> List of devices that must clear this flag is :
> >>>>>
> >>>>> - loopback device, because it calls netif_rx() and quoting Patrick :
> >>>>>     "ip_route_input() doesn't accept loopback addresses, so loopback packets
> >>>>>      already need to have a dst_entry attached."
> >>>>> - appletalk/ipddp.c : needs skb->dst in its xmit function
> >>>>>
> >>>>> - And all devices that call again dev_queue_xmit() from their xmit function
> >>>>> (as some classifiers need skb->dst) : bonding, macvlan, eql, ifb, hdlc_fr
> >>> Why not vlan (and/or maybe others in net/ using dev_queue_xmit)?
> >>>
> >> Yes I spoted vlan earlier this afternoon.
> >>
> >> For other net/*, I didnt not find candidates yet.
> > 
> > Hmm..., if vlan, then why not pppoe (and/or maybe others in drivers/net/
> > using dev_queue_xmit)?
> > 
> 
> As I said, I didnt found other relevant uses, but I am probably wrong :)
> 
> About ppoe for example, two calls to dev_queue_xmit() are not relevant.
> 
> One is from 
> 
> static int pppoe_sendmsg(struct kiocb *iocb, struct socket *sock,
>           struct msghdr *m, size_t total_len)
> 
> This is a normal direct call, not a call from its ndo_start_xmit()
> 
> Second one is from
> 
> static int __pppoe_xmit(struct sock *sk, struct sk_buff *skb)
> 
> Same observation, there is no impact for this one as well.
> 
> 
> 
> So we have to care on device drivers that have a ndo_start_xmit() call that could
> re-enter dev_queue_xmit(). Not care about drivers that call dev_queue_xmit() from
> other paths.
> 

Isn't it called through ppp_generic's ndo_start_xmit()?

Jarek P.